import mongoose, { connect, PopulatedDoc, Document } from "mongoose";
const { Schema, model } = mongoose;

interface IAbstractQM {
	index: number;
}

interface IQuickMenuLink extends IAbstractQM {
	title: string;
	url: string;
}

interface IQuickMenuDiv extends IAbstractQM {
	divider: boolean;
}

export type QuickMenuItem = IQuickMenuDiv | IQuickMenuLink;

export const QuickMenuSchema = new Schema<QuickMenuItem>({
	index: Number,
	// @ts-ignore SHUT UP BITCH I KNOW WHAT I'M DOING
	title: String,
	url: String,
	divider: Boolean,
});
